// Code generated by smithy-go-codegen DO NOT EDIT.

package query

import (
	"bytes"
	"context"
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/internal/protocoltest/query/types"
	"github.com/aws/smithy-go/middleware"
	smithyrand "github.com/aws/smithy-go/rand"
	smithytesting "github.com/aws/smithy-go/testing"
	smithyhttp "github.com/aws/smithy-go/transport/http"
	"io/ioutil"
	"net/http"
	"testing"
)

func TestClient_XmlIntEnums_awsAwsqueryDeserialize(t *testing.T) {
	cases := map[string]struct {
		StatusCode    int
		Header        http.Header
		BodyMediaType string
		Body          []byte
		ExpectResult  *XmlIntEnumsOutput
	}{
		// Serializes simple scalar properties
		"QueryXmlIntEnums": {
			StatusCode: 200,
			Header: http.Header{
				"Content-Type": []string{"text/xml"},
			},
			BodyMediaType: "application/xml",
			Body: []byte(`<XmlIntEnumsResponse xmlns="https://example.com/">
			    <XmlIntEnumsResult>
			        <intEnum1>1</intEnum1>
			        <intEnum2>2</intEnum2>
			        <intEnum3>3</intEnum3>
			        <intEnumList>
			            <member>1</member>
			            <member>2</member>
			        </intEnumList>
			        <intEnumSet>
			            <member>1</member>
			            <member>2</member>
			        </intEnumSet>
			        <intEnumMap>
			            <entry>
			                <key>a</key>
			                <value>1</value>
			            </entry>
			            <entry>
			                <key>b</key>
			                <value>2</value>
			            </entry>
			        </intEnumMap>
			    </XmlIntEnumsResult>
			</XmlIntEnumsResponse>
			`),
			ExpectResult: &XmlIntEnumsOutput{
				IntEnum1: 1,
				IntEnum2: 2,
				IntEnum3: 3,
				IntEnumList: []types.IntegerEnum{
					1,
					2,
				},
				IntEnumSet: []types.IntegerEnum{
					1,
					2,
				},
				IntEnumMap: map[string]types.IntegerEnum{
					"a": 1,
					"b": 2,
				},
			},
		},
	}
	for name, c := range cases {
		t.Run(name, func(t *testing.T) {
			serverURL := "http://localhost:8888/"
			client := New(Options{
				HTTPClient: smithyhttp.ClientDoFunc(func(r *http.Request) (*http.Response, error) {
					headers := http.Header{}
					for k, vs := range c.Header {
						for _, v := range vs {
							headers.Add(k, v)
						}
					}
					if len(c.BodyMediaType) != 0 && len(headers.Values("Content-Type")) == 0 {
						headers.Set("Content-Type", c.BodyMediaType)
					}
					response := &http.Response{
						StatusCode: c.StatusCode,
						Header:     headers,
						Request:    r,
					}
					if len(c.Body) != 0 {
						response.ContentLength = int64(len(c.Body))
						response.Body = ioutil.NopCloser(bytes.NewReader(c.Body))
					} else {

						response.Body = http.NoBody
					}
					return response, nil
				}),
				APIOptions: []func(*middleware.Stack) error{
					func(s *middleware.Stack) error {
						s.Finalize.Clear()
						s.Initialize.Remove(`OperationInputValidation`)
						return nil
					},
				},
				EndpointResolver: EndpointResolverFunc(func(region string, options EndpointResolverOptions) (e aws.Endpoint, err error) {
					e.URL = serverURL
					e.SigningRegion = "us-west-2"
					return e, err
				}),
				IdempotencyTokenProvider: smithyrand.NewUUIDIdempotencyToken(&smithytesting.ByteLoop{}),
				Region:                   "us-west-2",
			})
			var params XmlIntEnumsInput
			result, err := client.XmlIntEnums(context.Background(), &params)
			if err != nil {
				t.Fatalf("expect nil err, got %v", err)
			}
			if result == nil {
				t.Fatalf("expect not nil result")
			}
			if err := smithytesting.CompareValues(c.ExpectResult, result); err != nil {
				t.Errorf("expect c.ExpectResult value match:\n%v", err)
			}
		})
	}
}
