// Code generated by smithy-go-codegen DO NOT EDIT.

package controltower

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/controltower/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Enable (apply) a Baseline to a Target. This API starts an asynchronous
// operation to deploy resources specified by the Baseline to the specified Target.
func (c *Client) EnableBaseline(ctx context.Context, params *EnableBaselineInput, optFns ...func(*Options)) (*EnableBaselineOutput, error) {
	if params == nil {
		params = &EnableBaselineInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "EnableBaseline", params, optFns, c.addOperationEnableBaselineMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*EnableBaselineOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type EnableBaselineInput struct {

	// The ARN of the baseline to be enabled.
	//
	// This member is required.
	BaselineIdentifier *string

	// The specific version to be enabled of the specified baseline.
	//
	// This member is required.
	BaselineVersion *string

	// The ARN of the target on which the baseline will be enabled. Only OUs are
	// supported as targets.
	//
	// This member is required.
	TargetIdentifier *string

	// A list of key-value objects that specify enablement parameters, where key is a
	// string and value is a document of any type.
	Parameters []types.EnabledBaselineParameter

	// Tags associated with input to EnableBaseline .
	Tags map[string]string

	noSmithyDocumentSerde
}

type EnableBaselineOutput struct {

	// The ARN of the EnabledBaseline resource.
	//
	// This member is required.
	Arn *string

	// The ID (in UUID format) of the asynchronous EnableBaseline operation. This
	// operationIdentifier is used to track status through calls to the
	// GetBaselineOperation API.
	//
	// This member is required.
	OperationIdentifier *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationEnableBaselineMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpEnableBaseline{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpEnableBaseline{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "EnableBaseline"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpEnableBaselineValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opEnableBaseline(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opEnableBaseline(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "EnableBaseline",
	}
}
