// Code generated by smithy-go-codegen DO NOT EDIT.

package elasticsearchservice

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/elasticsearchservice/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Cancels a pending configuration change on an Amazon OpenSearch Service domain.
func (c *Client) CancelDomainConfigChange(ctx context.Context, params *CancelDomainConfigChangeInput, optFns ...func(*Options)) (*CancelDomainConfigChangeOutput, error) {
	if params == nil {
		params = &CancelDomainConfigChangeInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "CancelDomainConfigChange", params, optFns, c.addOperationCancelDomainConfigChangeMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*CancelDomainConfigChangeOutput)
	out.ResultMetadata = metadata
	return out, nil
}

// Container for parameters of the CancelDomainConfigChange operation.
type CancelDomainConfigChangeInput struct {

	// Name of the OpenSearch Service domain configuration request to cancel.
	//
	// This member is required.
	DomainName *string

	// When set to True, returns the list of change IDs and properties that will be
	// cancelled without actually cancelling the change.
	DryRun *bool

	noSmithyDocumentSerde
}

// Contains the details of the cancelled domain config change.
type CancelDomainConfigChangeOutput struct {

	// The unique identifiers of the changes that were cancelled.
	CancelledChangeIds []string

	// The domain change properties that were cancelled.
	CancelledChangeProperties []types.CancelledChangeProperty

	// Whether or not the request was a dry run. If True, the changes were not
	// actually cancelled.
	DryRun *bool

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationCancelDomainConfigChangeMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpCancelDomainConfigChange{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpCancelDomainConfigChange{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "CancelDomainConfigChange"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpCancelDomainConfigChangeValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opCancelDomainConfigChange(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opCancelDomainConfigChange(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "CancelDomainConfigChange",
	}
}
