// Code generated by smithy-go-codegen DO NOT EDIT.

package finspace

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/finspace/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Returns a list of scaling groups in a kdb environment.
func (c *Client) ListKxScalingGroups(ctx context.Context, params *ListKxScalingGroupsInput, optFns ...func(*Options)) (*ListKxScalingGroupsOutput, error) {
	if params == nil {
		params = &ListKxScalingGroupsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListKxScalingGroups", params, optFns, c.addOperationListKxScalingGroupsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListKxScalingGroupsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListKxScalingGroupsInput struct {

	// A unique identifier for the kdb environment, for which you want to retrieve a
	// list of scaling groups.
	//
	// This member is required.
	EnvironmentId *string

	// The maximum number of results to return in this request.
	MaxResults int32

	// A token that indicates where a results page should begin.
	NextToken *string

	noSmithyDocumentSerde
}

type ListKxScalingGroupsOutput struct {

	// A token that indicates where a results page should begin.
	NextToken *string

	// A list of scaling groups available in a kdb environment.
	ScalingGroups []types.KxScalingGroup

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListKxScalingGroupsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListKxScalingGroups{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListKxScalingGroups{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListKxScalingGroups"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = addRestJsonContentTypeCustomization(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpListKxScalingGroupsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListKxScalingGroups(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListKxScalingGroupsAPIClient is a client that implements the
// ListKxScalingGroups operation.
type ListKxScalingGroupsAPIClient interface {
	ListKxScalingGroups(context.Context, *ListKxScalingGroupsInput, ...func(*Options)) (*ListKxScalingGroupsOutput, error)
}

var _ ListKxScalingGroupsAPIClient = (*Client)(nil)

// ListKxScalingGroupsPaginatorOptions is the paginator options for
// ListKxScalingGroups
type ListKxScalingGroupsPaginatorOptions struct {
	// The maximum number of results to return in this request.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListKxScalingGroupsPaginator is a paginator for ListKxScalingGroups
type ListKxScalingGroupsPaginator struct {
	options   ListKxScalingGroupsPaginatorOptions
	client    ListKxScalingGroupsAPIClient
	params    *ListKxScalingGroupsInput
	nextToken *string
	firstPage bool
}

// NewListKxScalingGroupsPaginator returns a new ListKxScalingGroupsPaginator
func NewListKxScalingGroupsPaginator(client ListKxScalingGroupsAPIClient, params *ListKxScalingGroupsInput, optFns ...func(*ListKxScalingGroupsPaginatorOptions)) *ListKxScalingGroupsPaginator {
	if params == nil {
		params = &ListKxScalingGroupsInput{}
	}

	options := ListKxScalingGroupsPaginatorOptions{}
	if params.MaxResults != 0 {
		options.Limit = params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListKxScalingGroupsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListKxScalingGroupsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListKxScalingGroups page.
func (p *ListKxScalingGroupsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListKxScalingGroupsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	params.MaxResults = p.options.Limit

	result, err := p.client.ListKxScalingGroups(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opListKxScalingGroups(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListKxScalingGroups",
	}
}
