// Code generated by smithy-go-codegen DO NOT EDIT.

package lexmodelsv2

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/lexmodelsv2/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
	"time"
)

// The action to update the test set.
func (c *Client) UpdateTestSet(ctx context.Context, params *UpdateTestSetInput, optFns ...func(*Options)) (*UpdateTestSetOutput, error) {
	if params == nil {
		params = &UpdateTestSetInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "UpdateTestSet", params, optFns, c.addOperationUpdateTestSetMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*UpdateTestSetOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type UpdateTestSetInput struct {

	// The test set Id for which update test operation to be performed.
	//
	// This member is required.
	TestSetId *string

	// The new test set name.
	//
	// This member is required.
	TestSetName *string

	// The new test set description.
	Description *string

	noSmithyDocumentSerde
}

type UpdateTestSetOutput struct {

	// The creation date and time for the updated test set.
	CreationDateTime *time.Time

	// The test set description for the updated test set.
	Description *string

	// The date and time of the last update for the updated test set.
	LastUpdatedDateTime *time.Time

	// Indicates whether audio or text is used for the updated test set.
	Modality types.TestSetModality

	// The number of conversation turns from the updated test set.
	NumTurns *int32

	// The roleARN used for any operation in the test set to access resources in the
	// Amazon Web Services account.
	RoleArn *string

	// The status for the updated test set.
	Status types.TestSetStatus

	// The Amazon S3 storage location for the updated test set.
	StorageLocation *types.TestSetStorageLocation

	// The test set Id for which update test operation to be performed.
	TestSetId *string

	// The test set name for the updated test set.
	TestSetName *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationUpdateTestSetMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpUpdateTestSet{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpUpdateTestSet{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "UpdateTestSet"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpUpdateTestSetValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opUpdateTestSet(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opUpdateTestSet(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "UpdateTestSet",
	}
}
