// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	smithydocument "github.com/aws/smithy-go/document"
	"time"
)

// A structure that contains some information about a private re:Post in the
// account.
type SpaceData struct {

	// The ARN of the private re:Post.
	//
	// This member is required.
	Arn *string

	// The configuration status of the private re:Post.
	//
	// This member is required.
	ConfigurationStatus ConfigurationStatus

	// The date when the private re:Post was created.
	//
	// This member is required.
	CreateDateTime *time.Time

	// The name for the private re:Post.
	//
	// This member is required.
	Name *string

	// The AWS generated subdomain of the private re:Post.
	//
	// This member is required.
	RandomDomain *string

	// The unique ID of the private re:Post.
	//
	// This member is required.
	SpaceId *string

	// The creation/deletion status of the private re:Post.
	//
	// This member is required.
	Status *string

	// The storage limit of the private re:Post.
	//
	// This member is required.
	StorageLimit *int64

	// The pricing tier of the private re:Post.
	//
	// This member is required.
	Tier TierLevel

	// This custom subdomain that you use to access your private re:Post. All custom
	// subdomains must be approved by AWS before use.
	//
	// This member is required.
	VanityDomain *string

	// This approval status of the custom subdomain.
	//
	// This member is required.
	VanityDomainStatus VanityDomainStatus

	// The content size of the private re:Post.
	ContentSize *int64

	// The date when the private re:Post was deleted.
	DeleteDateTime *time.Time

	// The description for the private re:Post. This is used only to help you identify
	// this private re:Post.
	Description *string

	// The number of onboarded users to the private re:Post.
	UserCount *int32

	// The custom AWS KMS key ARN that’s used for the AWS KMS encryption.
	UserKMSKey *string

	noSmithyDocumentSerde
}

// Stores information about a field that’s passed inside a request that resulted
// in an exception.
type ValidationExceptionField struct {

	// The name of the field.
	//
	// This member is required.
	Message *string

	// Message describing why the field failed validation.
	//
	// This member is required.
	Name *string

	noSmithyDocumentSerde
}

type noSmithyDocumentSerde = smithydocument.NoSerde
